#!/bin/sh

root=`echo $0 | sed -e 's/\/.*$//'`
if [ -z "$root" ]; then
	nul=$0
else
	nul=`pwd`/$0
fi

DBDIR=`echo $nul | sed -e 's,bin/[a-z_\.]*$,db,'`;
BINDIR=`echo $nul | sed -e 's,/[a-z_\.]*$,,'`;

if [ ! -f ${DBDIR}/newports.db ]; then
	echo "Couldn't find location of newports.db. Please run $0 with the full path."
	exit
fi
if [ ! -f ${BINDIR}/find_new_versions.pl ]; then
	echo "Couldn't find location of find_new_versions.pl. Please run $0 with the full path."
	exit
fi

LOG=${DBDIR}/newports.log
CONCURRENT=${DBDIR}/concurrent

cd /usr/ports

> ${LOG}

test -f ${CONCURRENT} || echo 10 > ${CONCURRENT}

for c in `make -V SUBDIR`; do
	if [ ! -d $c ]; then
		echo "Couldn't find category $c" > ${LOG}
		continue
	fi
	cd $c
	for p in `make -V SUBDIR`; do
		while [ true ]; do
			j=`ps xauww | grep find_new_versions.pl | grep -v grep | wc -l`
			j=`expr $j + 0`
			if [ $j -lt `cat ${CONCURRENT}` ]; then
				break
			fi
			sleep 1
		done

		if [ ! -d $p ]; then
			echo "Couldn't find portsdir $p" > ${LOG}
			continue
		fi
		cd $p
		${BINDIR}/find_new_versions.pl $c/$p &
		cd ..
		echo `date` - $j - $c/$p >> ${LOG}
	done
	cd ..
done

while [ true ]; do
	j=`ps xauww | grep find_new_versions.pl | grep -v grep | wc -l`
	j=`expr $j + 0`
	if [ "$j" != "0" ]; then
		break
	fi
	echo "`date` - Still running: $j processes" >> ${LOG}
	sleep 10
done
